
# Variables for customisation:
#   - CLANG_FORMAT_EXECUTABLE:    Name/path of clang format executable
#   - CLANG_FORMAT_CONFIG:        Path to clang format config file
#   - CLANG_FORMAT_EXCLUDE_REGEX: Regex of files to exclude from clang-format

function(_cactus_add_clang_format_target_for_directory dir)

  # Call function recursively on subdirectories
  get_directory_property(subDirs DIRECTORY ${dir} SUBDIRECTORIES)
  foreach(subDir ${subDirs})
    _cactus_add_clang_format_target_for_directory(${subDir})
  endforeach()

  # Add format targets for each non-custom target
  get_directory_property(targets DIRECTORY ${dir} BUILDSYSTEM_TARGETS)
  foreach(target ${targets})
    get_target_property(targetType ${target} TYPE)
    if(targetType STREQUAL "UTILITY")
      continue()
    endif()

    get_target_property(sourceFiles ${target} SOURCES)
    file(GLOB_RECURSE headerFiles RELATIVE ${dir} *.h *.hh *.hpp *.hxx)
    list(FILTER headerFiles INCLUDE REGEX "^include.+")
    if (DEFINED CLANG_FORMAT_EXCLUDE_REGEX)
      list(FILTER headerFiles EXCLUDE REGEX ${CLANG_FORMAT_EXCLUDE_REGEX})
    endif ()

    # Remove auto-generated source files (since if they're generated by rule in subdirectory,
    #   cmake can't add that as dependency of the format targets defined here).
    set(generatedSourceFiles)
    foreach(sourceFile ${sourceFiles})
      get_source_file_property(sourceFileIsGenerated ${sourceFile} DIRECTORY ${dir} GENERATED)
      if(${sourceFileIsGenerated} EQUAL 1)
          list(APPEND generatedSourceFiles ${sourceFile})
      endif()
    endforeach()
    list(REMOVE_ITEM sourceFiles ${generatedSourceFiles})

    add_custom_target (
      clang-format.${target}
      COMMAND
        ${CLANG_FORMAT_EXECUTABLE} -style=file -i ${sourceFiles} ${headerFiles}
      WORKING_DIRECTORY
        ${dir}
      COMMENT
        "Formatting source code for ${target} (using ${CLANG_FORMAT_EXECUTABLE}) ..."
    )
    add_dependencies(clang-format clang-format.${target})

    add_custom_target(
      check-clang-format.${target}
      COMMAND
        ${CLANG_FORMAT_EXECUTABLE} -style=file -Werror --dry-run -ferror-limit=1 ${sourceFiles} ${headerFiles}
      WORKING_DIRECTORY
        ${dir}
      COMMENT
        "Checking formatting of source code for ${target} (using ${CLANG_FORMAT_EXECUTABLE}) ..."
    )
    add_dependencies(check-clang-format check-clang-format.${target})

  endforeach()
endfunction()


function(cactus_add_clang_format_targets)

  # 1) Find clang-format executable
  if (NOT CLANG_FORMAT_EXECUTABLE)
    set(CLANG_FORMAT_EXECUTABLE clang-format)
  endif ()

  if (NOT EXISTS ${CLANG_FORMAT_EXECUTABLE})
    find_program(CLANG_FORMAT_PROGRAM clang-format)
    if (CLANG_FORMAT_PROGRAM)
      set(CLANG_FORMAT_EXECUTABLE ${CLANG_FORMAT_PROGRAM})
      unset(CLANG_FORMAT_PROGRAM)
    else ()
      message(NOTICE "clang-format executable (${CLANG_FORMAT_EXECUTABLE}) not found! Adding dummy 'check-clang-format' and 'clang-format' targets")
      unset(CLANG_FORMAT_EXECUTABLE)
    endif ()
  endif ()

  # TODO: 2) Add symlink to custom CLANG_FORMAT_CONFIG if defined
  # If CMAKE_SOURCE_DIR/.clang-format does not exist:
  #   - If CLANG_FORMAT_CONFIG defined, then create symlink to that
  #   - Otherwise, create symlink to central .clang-format file

  # 3) Define format targets
  if (CLANG_FORMAT_EXECUTABLE)
    if(NOT TARGET clang-format)
      add_custom_target(clang-format)
    endif()
    if(NOT TARGET check-clang-format)
      add_custom_target(check-clang-format)
    endif()
    _cactus_add_clang_format_target_for_directory(${CMAKE_SOURCE_DIR})
  else()
    set(CLANG_FORMAT_NOT_FOUND_COMMAND_ARGS
      # show error message
      COMMAND ${CMAKE_COMMAND} -E echo "Cannot run because clang-format not found"
      # fail build
      COMMAND ${CMAKE_COMMAND} -E false
    )
    if(NOT TARGET clang-format)
      add_custom_target(clang-format ${CLANG_FORMAT_NOT_FOUND_COMMAND_ARGS})
    endif()
    if(NOT TARGET check-clang-format)
      add_custom_target(check-clang-format ${CLANG_FORMAT_NOT_FOUND_COMMAND_ARGS})
    endif()
  endif()

  if(TARGET format)
    add_dependencies(format clang-format)
  else()
    add_custom_target(format DEPENDS clang-format)
  endif()

  if(TARGET check-format)
    add_dependencies(check-format check-clang-format)
  else()
    add_custom_target(check-format DEPENDS check-clang-format)
  endif()

endfunction()